#COMPILER PBCC 5
#COMPILE EXE
#DIM ALL

DECLARE FUNCTION TextInput(Buffer AS STRING, Row AS LONG, Col AS LONG, _
                           History() AS STRING) AS LONG

FUNCTION PBMAIN () AS LONG  ' (c) 2015 Ben Ritchey
Local A, C, CC, CName, Drv, DrvList, DVol, Z as String
Local AA, B, D, SizeS, CX, CY, H, HH, I, II, K, KK, L, LL, LLen, M, T, TCol, TRow as Long
Local DirDataTab() as String
LOCAL MONTHTAB() AS STRING
Local EFlag, SFlag, VFlag, PName, PgmVer, SubDir, TBytes, BFree as string
  LOCAL buffer AS STRING
  LOCAL curPos AS LONG
  LOCAL retVal AS LONG
  LOCAL ti      AS LONG
  REDIM history1(0) AS STRING  'add a history array for each text field if needed.

  DIM DirDataTab(4096)
  Dim MonthTab(12)
  PgmVer=" DVWin v1.8.B "
  PName="DASD Vision for Windows 7 64-bit"
  CName=Environ$("COMPUTERNAME")
  SFLag="N"  ' N ame, -D ate new, -S ize big
  EFlag="DoEDPL.Bat "
  VFlag="DoGlogg.Bat "
  TRow=58
  TCol=132

  Drv="C": If Mid$(command$,2,1)=":" then Drv=mid$(command$,1,1)
  DrvList="C": On Error Resume Next
  for L=68 to 90
    ChDrive Chr$(L)
    If Err=0 then DrvList=DrvList+" "+Chr$(L): else Errclear
   Next L 
  On Error Goto 0
  ChDrive "C"

  FOR L=1 TO 12
    MONTHTAB(L)=READ$(L)
   NEXT L

Startup:

 Shell "cmd /c mode con cols="+Trim$(Str$(TCol))+" lines=58"
  reDIM DirDataTab(4096)

Shell "Cmd /c Dir /O:G"+SFlag+" /X >"+Drv+":\$DVWin$"
Open Drv+":\$DVWin$" for Input as #1

B=1
If K<1 then K=1
If K>=T then K=1
LLen=0: DVol=""
While not Eof(1)
  Line Input #1,A
  If Instr(A,"<DIR>")>0 and Instr(A," .")>0 then goto LoadNext
  If A<>"" and mid$(A,1,1)<>" " then
    If Mid$(A,3,1)="/" then Mid$(A,3,1)="-"
    If Mid$(A,6,1)="/" then Mid$(A,6,1)="-"
    If Mid$(A,1,1)="0" then Mid$(A,1,1)=" "
    If Mid$(A,13,1)="0" and Mid$(A,14,1)<>"0" then Mid$(A,13,1)=" "
    If Mid$(A,20,1)="M" then Mid$(A,20,1)="m"
    DirDataTab(B)=A: B=B+1
    If LLen<len(A) then LLen=len(A)+1
  End if

  l=instr(a,"Directory of")
  if l>0 then SubDir=Trim$(mid$(a,l+13))

  l=instr(a," File(s) ")
  if l>0 then TBytes=mid$(a,l+8)

  l=instr(a," bytes free")
  if l>0 then
    m=instr(a,"Dir(s)")
    BFree=mid$(a,m+6): Bfree=RTrim$(BFree," bytes free")
  End if

  l=instr(a," Volume in drive ")
  if l>0 then DVol=Trim$(mid$(a,23))

LoadNext:
WEnd

T=B
DirDataTab(T)="::EOF"
Close 1
If DVol="" then DVol="{none}"

B=1: I=K: SizeS=40: Z=""

NextScr:
K=I

GoSub NewScr

  Locate 55,16
  Color 14: Print mid$(Subdir,1,2);
  Color 7: Print " Bytes Free= ";
  Color 14: Print BFree;

  Locate 4,1
  Color 4: Print "  ";Using$("####",T-1);
  Color 7: Print "   Directory of  ";
  Color 14: Print SubDir;

  If T=1 or instr(SFlag,"/A:")>0 then
   If T=1 then color 4: print " is Empty! ";
   color 15
   If instr(sflag,":R") then Print "     READ ONLY files ... ";
   If instr(sflag,":H") then Print "     HIDDEN files ... ";
   If instr(sflag,":S") then Print "     SYSTEM files ... ";
   Color 7: Print " { DIR Args=";
   Color 14: Print "/O:";SFlag;" /X }";
  End if

  Locate 55,TCol-10: Color 7
  Print "  Work=";: Color 14: Print Drv;":"
  Locate 55,TCol-36: Color 7
  If Len(DrvList)>5 then Locate ,TCol-36-(Len(DrvList)-5)
  Print "  Available Drives: ";: Color 14: Print DrvList

  Locate 2,8
  Color 6,7
  Print " Volume ID: ";
  Color 1,7
  Print " ";DVol;" "
  Print
  If T=1 then goto getfunc

  Locate 6,1
  Color 1,7
  Print space$(TCol);
  Locate 6,1
  Print "  ";chr$(213);"R#";chr$(184);
  Print "  ";chr$(213);chr$(205);chr$(205);"Date";chr$(205);chr$(205);chr$(184);
  Print "  ";chr$(213);chr$(205);"Time";chr$(205);chr$(184);
  Print "  ";chr$(213);string$(4,chr$(205));" Bytes";string$(4,chr$(205));chr$(184);
  Print " ";chr$(213);string$(3,chr$(205));" SFN";string$(3,chr$(205));chr$(184);
  Print " ";chr$(213);string$(3,chr$(205));" LFN ..."
  Color 7,1

'Locate 7,1
While DirDataTab(I)<>"::EOF" and B<=SizeS
  A=DirDataTab(I): B=B+1: I=I+1
'  If A="" or A=Space$(Len(A)) then goto BadData
  If instr(a,"<DIR>")>0 then Color 6 else Color 4
  Print "  ";Using$("####",I-1);
  If instr(a,"<DIR>")>0 then Color 7 else Color 15
  Print "  ";
  If len(a)>=TCol-14 then print mid$(a,1,TCol-10);: else Print a;
  If len(A)<TCol-14 and LLen<TCol-14 then 
    Print space$(LLen-len(A));
    If instr(a,"<DIR>")>0 then Color 6 else Color 4
    Print "  ";Using$("####",I-1)
   else
    Print
  end if
  Color 7

BadData:
wend  

KK=I-K-1

CY=CursorY
If I>=T then Print String$(TCol,chr$(205));
Locate CY,10
Color 6: Print " Total Sub-Dir Alloc= ";
Color 14: Print TBytes;" ";
If I<T then Print "  ... continued ";

locate 55,54
Color 7: Print "  { DIR Args=";
Color 14: Print "/O:";SFlag;" /X ";
Color 7: Print "}"
Color 7
If H<1 or H>=T or H>SizeS or H>KK then H=1
Gosub HiLite

GetFunc:

'Print
'Locate SizeS+10,1
Locate 56,1
Color 0,7
Print space$(TCol*2);
locate 56,1
Print "  Scroll=PageDown/Up/Home/End/  INSert=Command  F2=Exec  SPace=Mark  F8=Do Marks  F9=Drive  Home=Reset All  F3=Exit  Alt+H=Help "
Print "    ATTR=F5:R/O, F6:Hidden, F7:System  Sort=F10:NAME, F11:DATE, F12:SIZE  Enter/=EDit or ChDir <DIR>  Esc/=ChDir ..  F4=View ";

Locate SizeS+9,1
Cursor OFF
C=""
While C=""
 Gosub DOTOD
 If Instat=0 then Sleep 50
 C=Inkey$
WEnd
Cursor ON, 100

If len(C)=2 then
  if mid$(C,2,1)=chr$(72) then H=H-1: Gosub HiLite: goto GetFunc  ' Up arw
  if mid$(C,2,1)=chr$(80) then H=H+1: Gosub HiLite: goto GetFunc  ' Down arw
  if mid$(C,2,1)=chr$(75) then ChDir "..": goto Startup  ' Left arw = ..
  if mid$(C,2,1)=chr$(77) then goto Parse13  ' Right arw = Enter simulation (EDit)
  if mid$(C,2,1)=chr$(62) then goto doglogg  ' F4 = View
  if mid$(C,2,1)=chr$(81) then goto DoNext  ' PageDown
  if mid$(C,2,1)=chr$(73) then goto DoPrev  ' PageUp
  if mid$(C,2,1)=chr$(71) then SFLag="N": H=1: K=1: goto Startup  ' Home/Reset
  if mid$(C,2,1)=chr$(82) then goto DoCmd  ' Insert
  if mid$(C,2,1)=chr$(60) then C="== ": goto Execit  ' F2=Exec
  if mid$(C,2,1)=chr$(35) then C="cmd /c Start PBCC.Chm": goto Execit  ' Alt+H=Help
  if mid$(C,2,1)=chr$(83) then goto DoKill  ' Delete
  if mid$(C,2,1)=chr$(61) then goto Enditall  ' F3 = Exit
  if mid$(C,2,1)=chr$(45) then goto Enditall  ' Alt+X = Exit
  if mid$(C,2,1)=chr$(79) then K=T-SizeS: goto Startup  ' End
  if mid$(C,2,1)=chr$(66) then goto DoMarked  ' F8=Do marks
  if mid$(C,2,1)=chr$(68) then SFlag="N": goto Startup  ' F10=Name sort
  if mid$(C,2,1)=chr$(87) then SFlag="-D": goto Startup  ' F11=-Date sort
  if mid$(C,2,1)=chr$(88) then SFlag="-S": goto Startup  ' F12=-Size sort
  if mid$(C,2,1)=chr$(63) then SFlag="N /A:R": goto Startup  ' F5=R/O files
  if mid$(C,2,1)=chr$(64) then SFlag="N /A:H": goto Startup  ' F6=Hidden files
  if mid$(C,2,1)=chr$(65) then SFlag="N /A:S": goto Startup  ' F7=System files
end if

If C=Chr$(9) then H=H+(SizeS/4): Gosub HiLite: goto GetFunc ' Tab

If len(C)=2 and mid$(C,2,1)=chr$(67) then  ' F9=Drive
 Print "Select DRIVE {";DrvList;", or Enter to Abort} ";

Getdrv:
 Locate ,36+Len(DrvList)
 A=""
 While A=""
  Gosub DOTOD
  If Instat=0 then Sleep 50
  A=Inkey$
 WEnd

 If A=Chr$(13) then goto Startup
 If len(A)<>1 then Beep: goto Getdrv
 If Asc(A)>=97 and Asc(A)<=122 then A=Chr$(Asc(A)-32)  ' force Uppercase
 If Asc(A)<65 or Asc(A)>90 then Beep: goto Getdrv

 On Error Resume Next
 ChDrive A
 If Err=76 then Errclear: Beep: Print " *** Error: Drive ";A;": does NOT Exist! ";: goto Getdrv

 On Error goto 0
' Locate ,1: Print Space$(TCol);: Locate ,1
 Goto Startup
End if

If C=" " then 
  If Mid$(DirDataTab(K+H-1),52,1)=" " then
    Mid$(DirDataTab(K+H-1),52,1)=chr$(251)
   else
    Mid$(DirDataTab(K+H-1),52,1)=" "
  End if

  Gosub HiLite
'  H=H+1
'  Gosub HiLite

 goto GetFunc ' Tab
End if

if C=chr$(13) then  ' ENTER key = ChDir if <DIR>, else Edit

Parse13:
 A=Trim$(Mid$(DirDataTab(K+H-1),53))
 Z=Trim$(Mid$(DirDataTab(K+H-1),40,12))

 If Instr(DirDataTab(K+H-1),"<DIR>")>0 then
   ChDir A
   Goto Startup
  Else
   If Z<>"" then A=Z
   Shell "Cmd /c "+EFlag+A
  goto Startup
 End if  
End if

If C="na" or C="Na" then 
DoNext:
  B=1
  I=K+SizeS
  If I>=T Then I=1
  Goto NextScr
End if

If C="pa" or C="Pa" then 
DoPrev:
  B=1
  If K>SizeS then I=K-SizeS else I=1
  Goto NextScr
End if

'If C="c" or C="C" then goto DoCmd

If C=Chr$(27) then
 If SubDir="C:\" then goto ENDITALL
 ChDir "..": goto Startup
End if

beep: goto GetFunc

Goto ENDITALL

'* * * * * * * * Sub-routines * * * * * * * *

DoGlogg:  ' F4 = View file

 A=Trim$(Mid$(DirDataTab(K+H-1),53))
 Z=Trim$(Mid$(DirDataTab(K+H-1),40,12))

 If Instr(DirDataTab(K+H-1),"<DIR>")>0 then
   Beep
   Goto Startup
  Else
   If Z<>"" then A=Z
   Shell "Cmd /c "+VFlag+A
  goto Startup
 End if  
Return

DoMarked:

Print
Print "Notes: == will INSERT each Marked Directory/File NAME(s) in the current line (i.e. COPY == ==2 or DEL ==) "
'Print
Print "DOS Command? {or ENTER to Abort} "
Print " > ";

CX=CURSORX: CY=CURSORY
If (TCol*2)-3 > 255 then buffer=space$(255) else buffer=space$((TCol*2)-3)
retVal = TextInput(buffer, CY, CX, history1())

C=Trim$(buffer)

If C="" goto Startup

CC=C
II=1
Cls

NxtMark:
While II<T and mid$(DirDataTab(II),52,1)=" ": II=II+1: WEnd
If II=T goto EndMark

'Print "hit on rec#";II  ' *** Debug ***
C=CC
While instr(C,"==")>0
  L=instr(C,"==")
  B=II  ' Current line
  If B<=0 or B>=T then goto Startup  ' Abort, bad Rec #

  A=DirDataTab(B)
  If len(A)>52 and mid$(A,53,1)<>" " then A=mid$(A,53) else A=""  ' Extract LFN
  If len(A)>39 and mid$(A,40,1)<>" " then A=trim$(mid$(A,40,12))  ' Prefer SFN
  If A="" then II=II+1: goto NxtMark

'Print "Parsing file ";A  ' *** Debug ***
  Z=mid$(C,L+2)
': M=instr(Z," ")
'  If M>0 then Z=mid$(Z,M) else Z=""
  C=mid$(C,1,L-1)+A+Z
wend  

Color 7: Print "Executing [";
Color 14: Print C;
Color 7: Print "] ..."
Shell "Cmd /c "+C
II=II+1
Goto NxtMark

EndMark:
Print
Color 6: Print String$(TCol,"_")
Color 15: Print "Press ENTER Key to continue ...";: Input A
Color 7: A=""

Goto Startup

DoKill:
 L=instr(DirDataTab(K+H-1),"<DIR>")
 If L>0 then Beep: goto Getfunc

 A=Trim$(Mid$(DirDataTab(K+H-1),53))  ' Parse LFN
 C=A
 Z=Trim$(Mid$(DirDataTab(K+H-1),40,12))  ' Parse SFN
 If Z<>"" then A=Z  ' Prefer SFN

 Color 4,0: Print "Delete";
 color 7: Print " file ";
 Color 11: Print C;
 Color 7: Print " {";
 Color 11: Print Z;
 Color 7: Print "} ";
 Color 4: Print "???";
 Color 7: Print " [Y=Yes] ";
 C=Waitkey$
 If C="y" or C="Y" then Kill A else Beep
goto Startup

HiLite:

 If H<1 then H=1
 If H>SizeS then H=SizeS
 If DirDataTab(K+H-1)="::EOF" or K+H-1>=T then K=(int(T/SizeS)*SizeS)+1: goto Startup

 If HH>=1 and HH<=SizeS and K+HH-1<T then  ' Undo HiLite
  Locate 6+HH,1
  Color 7,1
  Print Space$(TCol);
  Locate 6+HH,1
  If instr(DirDataTab(K+HH-1),"<DIR>")>0 then Color 6 else Color 4
  Print "  ";Using$("####",K+HH-1);
  If instr(DirDataTab(K+HH-1),"<DIR>")>0 then Color 7 else Color 15
  Print "  ";DirDataTab(K+HH-1);

  If len(DirDataTab(K+HH-1))<(TCol-14) and LLen<(TCol-14) then 
    Print space$(LLen-len(DirDataTab(K+HH-1)));
    If instr(DirDataTab(K+HH-1),"<DIR>")>0 then Color 6 else Color 4
    Print "  ";Using$("####",K+HH-1)
    else
    Print
  end if
  Color 7
 End if

Redoit:  ' HILite current line
 Locate 6+H,1
 Color 14,3
 Print Space$(TCol);
 Locate 6+H,1
 Print "  ";Using$("####",K+H-1);
 Print "  ";DirDataTab(K+H-1);

  If len(DirDataTab(K+H-1))<(TCol-14) and LLen<(TCol-14) then 
    Print space$(LLen-len(DirDataTab(K+H-1)));
    Print "  ";Using$("####",K+H-1)
   else
    Print
  end if
 Color 7,1

 HH=H  ' Set prev Hilite Row

Return

DoCmd:

'Print
Print "Notes: == Inserts Directory/File NAME on current line,  ::nn Inserts Directory/File NAME from line nn "
Print "  DOS Command? {or ENTER to Abort}                       ==.. to Move UP one or more Directory levels "
Print
Print " > ";

CX=CURSORX: CY=CURSORY
If (TCol*2)-3 > 255 then buffer=space$(255) else buffer=space$((TCol*2)-3)
retVal = TextInput(buffer, CY, CX, history1())

C=Trim$(buffer)

Execit:
If C="" goto Startup
CC=C

If UCase$(mid$(C,1,3))="CD " then Chdir mid$(C,4): Goto Startup
If UCase$(mid$(C,1,6))="CHDIR " then Chdir mid$(C,7): Goto Startup

If Mid$(C,1,4)="==.." then K=1: CHDIR Mid$(C,3): Goto Startup

While instr(C,"==")>0
  L=instr(C,"==")
  B=K+H-1  ' Current line
  If B<=0 then goto Startup  ' Abort, bad Rec #

  If B<T then A=DirDataTab(B) else A=""
  If len(a)>52 and mid$(A,53,1)<>" " then A=mid$(A,53) else A=""  ' Extract LFN

  Z=mid$(C,l+2): M=instr(Z," ")
  If M>0 then Z=mid$(Z,M) else Z=""
'  C=mid$(C,1,L-1)+chr$(34)+A+chr$(34)+Z  ' quotes?
  C=mid$(C,1,L-1)+A+Z
wend  

While instr(C,"::")>0
  L=instr(C,"::")
  B=val(mid$(c,l+2))
  If B=0 then goto Startup  ' Abort, bad Rec #

  If B<T then A=DirDataTab(B) else A=""
  If len(a)>52 and mid$(A,53,1)<>" " then A=mid$(A,53) else A=""  ' Extract LFN

  Z=mid$(C,l+2): M=instr(Z," ")
  If M>0 then Z=mid$(Z,M) else Z=""
'  C=mid$(C,1,L-1)+chr$(34)+A+chr$(34)+Z  ' quotes?
  C=mid$(C,1,L-1)+A+Z
wend  

Cls
Color 7: Print "Executing [";
Color 14: Print C;
Color 7: Print "] ..."

Shell "Cmd /c "+C
If mid$(C,1,3)="cd " or mid$(C,1,3)="CD " then K=1
If mid$(C,1,6)="chdir " or mid$(C,1,6)="CHDIR " then K=1

Print
Color 6: Print String$(TCol,"_")
Color 15: Print "Press any Key to continue ...";: Input A
Color 7: A=""

Goto Startup

Goto ENDITALL

NewScr:
  Color 7,1
  Cls
  Color 1,7: Print Space$(TCol*2);
200
'  Print "....+...10....+...20....+...30....+...40....+...50....+...60....+...70....+...80....+...90....+..100....+..110....+..120....+..130.."
  Locate 1,2
  Print PgmVer;
  Locate ,Int((TCol - LEN(PNAME$)) / 2): Print PNAME$;

  Locate 2,TCol-Len(CName)-12: Print Chr$(230);"P: ";CName; 

  Locate 2,55
  Color 12: Print " {c} 2015 Ben Ritchey ";
  Color 1

  Z=Z+MONTHTAB(VAL(MID$(DATE$,1,2)))+STR$(VAL(MID$(DATE$,4,2)))
  A="th": AA=VAL(MID$(DATE$,4,2))
  IF AA=1 OR AA=21 OR AA=31 THEN A="st"
  IF AA = 2 OR AA = 22 THEN A = "nd"
  IF AA = 3 OR AA = 23 THEN A = "rd"
  Z = Z + A + ", " + MID$(DATE$, 7, 4): AA=127-LEN(Z)
  Locate 1,(TCol-34): Print Z;"  ";: Z=""

  GOSUB DOTOD

  Color 7,1
'  Print

 Return

DOTOD:
  CX=CURSORX: CY=CURSORY
  Z=TIME$: AA=VAL(MID$(TIME$, 1, 2))
  IF AA>11 THEN Z=Z+" Pm" ELSE Z=Z+" Am"
  IF AA>12 THEN
    A=MID$(STR$(AA-12),2)
    IF LEN(A)=1 THEN A=" "+A
    MID$(Z,1)=A: A=""
  END IF
   Locate 1,(TCol-13): Color 0,7: PRINT " ";Z;"  ";: Z=""
  LOCATE CY,CX
  Color 7,1
 RETURN

ENDITALL:

REM Month Table Data
DATA January, February, March, April, May, June
DATA July, August, September, October, November, December
END FUNCTION

' TextInput function (c) 2005 Geo Massar

FUNCTION TextInput(Buffer AS STRING, Row AS LONG, Col AS LONG, _
                   History() AS STRING) AS LONG
  STATIC InsertOff    AS LONG
  LOCAL  BufferLen    AS LONG
  LOCAL  MyKey        AS STRING
  LOCAL  KeyVal       AS LONG
  LOCAL  ColorDefault AS BYTE
  LOCAL  CurPos       AS LONG
  LOCAL  HistoryIdx   AS LONG

  BufferLen = LEN(Buffer)
  HistoryIdx = UBOUND(History)                 'index to the empty slot
  ColorDefault = SCREENATTR(CURSORY,CURSORX)
  LOCATE Row, Col : COLOR 15, 1, BufferLen     'bright white against dark blue
  PRINT String$(BufferLen,chr$(249)); : LOCATE Row, Col
  CurPos = 1

  DO
    MyKey = WAITKEY$
    SELECT CASE LEN(MyKey)
      CASE 1    : KeyVal = ASC(MyKey)
      CASE 2    : KeyVal = - ASC(MyKey, 2)
      CASE ELSE : ITERATE
    END SELECT

    SELECT CASE KeyVal
      CASE 13, 9  'Enter, Tab
        COLOR ColorDefault MOD 16, ColorDefault \ 16
        FUNCTION = KeyVal
        IF TRIM$(Buffer) = "" THEN EXIT FUNCTION
        HistoryIdx = UBOUND(History)
        IF HistoryIdx > 0 THEN IF Buffer = History(HistoryIdx-1) THEN EXIT FUNCTION
        History(HistoryIdx) = Buffer
        INCR HistoryIdx
        REDIM PRESERVE History(HistoryIdx)
        History(HistoryIdx) = SPACE$(BufferLen)  'new slot for the next entry
        EXIT FUNCTION

      CASE 27  ' ESCape
        CurPos = 1

      CASE -72  'Up
        IF HistoryIdx > 0 THEN  DECR HistoryIdx
        Buffer = History(HistoryIdx)
        CurPos = LEN(RTRIM$(Buffer)) + 1

      CASE -80  'Down
        IF HistoryIdx < UBOUND(History) THEN INCR HistoryIdx
        Buffer = History(HistoryIdx)
        CurPos = LEN(RTRIM$(Buffer)) + 1

      CASE -82 'Insert
       IF InsertOff THEN
         InsertOff = 0
         CURSOR ON, 1
       ELSE
         InsertOff = 1
         CURSOR ON, 100
       END IF

      CASE 8 'BackSpace
       IF CurPos > 1 THEN
         DECR CurPos
         Buffer = LEFT$(Buffer, CurPos - 1) & MID$(Buffer, CurPos + 1) & " "
       END IF

      CASE -75 'Left
       IF CurPos > 1 THEN DECR CurPos

      CASE -77 'Right
       IF CurPos < BufferLen THEN INCR CurPos

      CASE -71 'Home
       CurPos = 1

      CASE -79 'End
       CurPos = MIN(LEN(RTRIM$(Buffer)) + 1, BufferLen)

      CASE -83 'Del
       Buffer = LEFT$(Buffer, CurPos - 1) & MID$(Buffer, CurPos + 1) & " "

      CASE 32 TO 255 'Valid charaters
       IF InsertOff THEN
         MID$(Buffer, CurPos, 1) = MyKey
       ELSE
         Buffer = LEFT$(Buffer, CurPos - 1) & MyKey & MID$(Buffer, CurPos, BufferLen - CurPos)
       END IF
       IF CurPos < BufferLen THEN INCR CurPos

      CASE ELSE
       ITERATE
    END SELECT

    LOCATE Row, Col
    PRINT Buffer;
    LOCATE Row, Col + CurPos - 1
  LOOP
END FUNCTION
' End of DVWin.Bas
